import java.io.*;
import java.util.*;

public class Clockwork {
    public static void main(String[] args) throws IOException {
	BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

	String s = br.readLine();
	if (s.charAt(0) == '0') {
	    System.out.println("-1");
	    return;
	}

	int length = s.length();
	boolean[] number = new boolean[length];
	boolean ok = true;
	for (int i = 0; i < length; i++) {
	    number[i] = s.charAt(i) == '1';
	    ok &= number[i];
	}
	if (ok) {
	    System.out.println(0);
	    return;
	}

	int count = 0;
	while (true) {
	    int longest = 0;
	    int longestIndex = -1;
	    int current = 0;

	    for (int i = 1; i < length; i++) {
		if (number[i] == false) {
		    current++;
		} else if (current > longest) {
		    longest = current;
		    longestIndex = i-current;
		    current = 0;
		} else {
		    current = 0;
		}
	    }
	    if (current > longest) {
		longest = current;
		longestIndex = length-current;
	    }

	    int best = 0;
	    int min = longestIndex - longest;
	    if (min < 0) min = 0;
	    for (int i = longestIndex - 1; i >= min; i--) {
		if (number[i]) best++;
	    }
	    current = best;
	    int bestIndex = longestIndex - 1;
	    int k = longestIndex - 1;
	    for (int i = min - 1; i >= 0; i--) {
	    	if (number[i]) current++;
		if (number[k]) current--;
		k--;
		if (current > best) {
		    best = current;
		    bestIndex = k;
		}
	    }
	    if (bestIndex < longest) {
	    	longest = bestIndex + 1;
	    }

	    int shift = longest - 1 + longestIndex - bestIndex;


	    count++;

	    boolean[] temp = new boolean[length];
	    for (int i = 0; i < length; i++) {
		temp[i] = number[i];
	    }
	    for (int i = shift; i < length; i++) {
	    	temp[i] = number[i] || number[i-shift];
	    }
	    number = temp;
	     ok = true;
	    for (int i = 0; i < length; i++) {
		ok &= number[i];
	    }
	    //for (int i = 0; i < length; i++) {
	    	//System.out.print(number[i] ? '1' : '0');
	    //}
	    //System.out.println();

	    if (ok) break;


	}
	System.out.println(count);


    }
}
