import java.io.*;

public class Lamps {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		int max = 1000001;
		int[] values = new int[max];
		for (long i = 1; i < 101; i++) {
			for (int j = (int)i+1; j < max; j++) {
				if (i*j >= max || i*j < 0) break;
				for (int k = j+1; k < max; k++) {
					if (i*j*k >= max || i*j*k < 0) break;
					values[(int)i*j*k]++;
				}
			}
		}
		for (int i = 1; i < max; i++) {
			values[i] += values[i-1];
		}
		int N = Integer.parseInt(br.readLine());
		for (int i = 0; i < N; i++) {
			int x = Integer.parseInt(br.readLine());
			System.out.println(values[x]);
		}

		br.close();
	}
}
